
#include "io.h"

extern __inline void PortOut (enum port io, unsigned int pos, enum state v)  {
  switch (io)  {
    case IO0:
      if (v == OFF)  IOCLR0 |= pos;
      else           IOSET0 |= pos;
      break;

    case IO1:
      if (v == OFF)  IOCLR1 |= pos;
      else           IOSET1 |= pos;
      break;
  }
}

extern __inline void LED (unsigned int no, enum state v)  {
  if (no < 8)  {
    PortOut (IO1, 1<<(no+8), v);
  }
  else  {
    PortOut (IO0, 1<<(no-8), v);
  }
} 

void change_state (void)  {
  LED (5, ON);
  LED (12, OFF);
}

