/***********************************************************************/
/*  This file is part of the CARM Compiler package                     */
/*  Copyright KEIL ELEKTRONIK GmbH 2002 - 2005                         */
/***********************************************************************/
/*                                                                     */
/*  GETKEY.C:  This routine is the general character input of CARM.    */
/*  You may add this file to a uVision project.                        */
/*                                                                     */
/*  To translate this file use CARM with the following invocation:     */
/*     CA GETKEY.C                                                     */
/*                                                                     */
/*  To link the modified GETKEY.OBJ file to your application use the   */
/*  following LA invocation:                                           */
/*     LA <your object file list>, GETKEY.OBJ <controls>               */
/*                                                                     */
/***********************************************************************/

/* Universal Asynchronous Receiver Transmitter 1 (UART1) */
#define U1RBR      (*((volatile unsigned char *) 0xE0010000))
#define U1THR      (*((volatile unsigned char *) 0xE0010000))
#define U1IER      (*((volatile unsigned char *) 0xE0010004))
#define U1IIR      (*((volatile unsigned char *) 0xE0010008))
#define U1FCR      (*((volatile unsigned char *) 0xE0010008))
#define U1LCR      (*((volatile unsigned char *) 0xE001000C))
#define U1MCR      (*((volatile unsigned char *) 0xE0010010))
#define U1LSR      (*((volatile unsigned char *) 0xE0010014))
#define U1MSR      (*((volatile unsigned char *) 0xE0010018))
#define U1SCR      (*((volatile unsigned char *) 0xE001001C))
#define U1DLL      (*((volatile unsigned char *) 0xE0010000))
#define U1DLM      (*((volatile unsigned char *) 0xE0010004))

#include <stdio.h>

// this version of putchar is configured for the Keil MCB2100 Board

int _getkey ()  {
  while (!(U1LSR & 0x01));
  return (U1RBR);
}
