/******************************************************************************/
/*  This file is part of the CA ARM C Compiler package                        */
/*  Copyright KEIL ELEKTRONIK GmbH 2002 - 2004                                */
/******************************************************************************/
/*                                                                            */
/*  DABT.S:  Data Abort Handler                                               */
/*                                                                            */
/******************************************************************************/


AREA ?C?DABT, CODE, READONLY, ALIGN=2

EXTERN CODE32 (AbortHandler?A)

PUBLIC DAbt_Handler?A

DAbt_Handler?A  PROC    CODE32
             
                SUB     LR, LR, #8          ; Update Link Register
                STMFD   SP!, {R0-R12, LR}   ; Save Workspace & LR into Stack
                MRS     R1, SPSR            ; Copy SPSR into R1
                STMFD   SP!, {R1}           ; Save SPSR into Stack
                BL      AbortHandler?A      ; Branch to Data Abort Handler
                LDMFD   SP!, {R1}           ; Restore SPSR into R1
                MSR     SPSR_CXSF, R1       ; Restore SPSR
                LDMFD   SP!, {R0-R12, PC}^  ; Return to program after
                                            ; Data Abort Instruction
         
                ENDP


                END
