/******************************************************************************/
/*  This file is part of the CA ARM C Compiler package                        */
/*  Copyright KEIL ELEKTRONIK GmbH 2002 - 2004                                */
/******************************************************************************/
/*                                                                            */
/*  PABT.S:  Prefetch Abort Handler                                           */
/*                                                                            */
/******************************************************************************/


AREA ?C?PABT, CODE, READONLY, ALIGN=2

EXTERN CODE32 (PrefetchHandler?A)

PUBLIC PAbt_Handler?A

PAbt_Handler?A  PROC    CODE32
             
                SUB     LR, LR, #4          ; Update Link Register
                STMFD   SP!, {R0-R12, LR}   ; Save Workspace & LR into Stack
                MRS     R1, SPSR            ; Copy SPSR into R1
                STMFD   SP!, {R1}           ; Save SPSR into Stack
                BL      PrefetchHandler?A   ; Branch to Prefetch Abort Handler
                LDMFD   SP!, {R1}           ; Restore SPSR into R1
                MSR     SPSR_CXSF, R1       ; Restore SPSR
                LDMFD   SP!, {R0-R12, PC}^  ; Return to program after
                                            ; Prefetch Abort Instruction
         
                ENDP


                END
