/******************************************************************************/
/*  This file is part of the CA ARM C Compiler package                        */
/*  Copyright KEIL ELEKTRONIK GmbH 2002 - 2004                                */
/******************************************************************************/
/*                                                                            */
/*  UNDEF.S:  Undefined Handler                                               */
/*                                                                            */
/******************************************************************************/


AREA ?C?UNDEF, CODE, READONLY, ALIGN=2

EXTERN CODE32 (UndefinedHandler?A)

PUBLIC Undef_Handler?A

Undef_Handler?A PROC    CODE32
             
                STMFD   SP!, {R0-R12, LR}   ; Save Workspace & LR into Stack
                MRS     R1, SPSR            ; Copy SPSR into R1
                STMFD   SP!, {R1}           ; Save SPSR into Stack
                BL      UndefinedHandler?A  ; Branch to Undefined Handler
                LDMFD   SP!, {R1}           ; Restore SPSR into R1
                MSR     SPSR_CXSF, R1       ; Restore SPSR
                LDMFD   SP!, {R0-R12, PC}^  ; Return to program after
                                            ; Undefined Instruction
         
                ENDP


                END
